--Vss_Deli24 GameDirector lua

--Change music events for Vss_Deli24 during Battle Plus timed matches

local starttime = (6*TICRATE + (3*TICRATE/4))

rawset(_G, "deli_timelimit", 0)
rawset(_G, "deli_overtimemode", false)

addHook("NetVars", function(net)
	server.deli_timelimit = net(server.deli_timelimit)
	server.deli_overtimemode = net(server.deli_overtimemode)
end)

addHook("MapLoad", function()
	server.deli_timelimit = 0
	server.deli_overtimemode = false
end)

local function gettimelimit()
	server.deli_timelimit = 0
	server.deli_overtimemode = false
	--p.sisters = P_RandomChance(FRACUNIT/3)	
	--p.theme = P_RandomChance(FRACUNIT/2)
	if battleplus then
		--code taken from Battle Plus
		if server.bp_gamemodehell > 0 then		-- we didn't get gamemode hell...
			if server.bp_teamgamemode > 0 then		-- we didn't get a team gamemode...
				local mode = server.bp_gamemode
				if mode == 1 then
					server.deli_timelimit = cv_bp_bb_tl.value
				end
				if mode == 2 then
					server.deli_timelimit = cv_bp_rr_tl.value
				end
				if mode == 4 then
					server.deli_timelimit = cv_bp_mb_tl.value
				end
				--print(mode)
			else
				local mode = server.bp_gamemode
				if mode == 1 then
					server.deli_timelimit = cv_bp_bb_tl.value
				end
				if mode == 2 then
					server.deli_timelimit = cv_bp_rr_tl.value
				end
				if mode == 3 then
					server.deli_timelimit = cv_bp_mb_tl.value
				end
				--print(mode)
			end	
		else 
			local mode = server.bp_gamemode
			if mode == 1 then
				server.deli_overtimemode = true
				server.deli_timelimit = cv_bp_sd_tl.value
			end			
		end
	else
		server.deli_timelimit = CV_FindVar("timelimit").value
	end
	--print(server.deli_timelimit)
end

freeslot("sfx_delbop", "sfx_cntgo")
addHook("ThinkFrame", do
	if gamemap == 295 then	--ONLY run for DeliPipe
		
		if leveltime == TICRATE/4 then
			S_StartSound(nil, sfx_delbop)	--play battle intro
		end
		if leveltime == (6*TICRATE + (3*TICRATE/4)) then
			S_StartSound(nil, sfx_cntgo)	--play gamedirector "GO"
		end
	
		--if not deli_timelimit then deli_timelimit = 0 end
		--if not p.sisters then p.sisters = 0 end
		--if not p.mus then p.mus = 0 end
		
		if leveltime == 106 then
			gettimelimit()
		end
	end
end)

addHook("ThinkFrame", do
	if gamemap ~= 295 then return end
	for p in players.iterate do
		if leveltime >= (starttime + (TICRATE/2) + 1) then
			if server.deli_timelimit > 1 and (p.kartstuff[k_growshrinktimer] == 0 and p.kartstuff[k_invincibilitytimer] == 0) then		--hacky problems call for hacky solutions
				if (battleplus) and p.realtime >= (server.deli_timelimit*60*TICRATE + 1*TICRATE) and server.bp_roundstalemate then continue end
				if (p.pflags & PF_TIMEOVER) then continue end
				if server.deli_timelimit == 3 then
					if p.realtime < (server.deli_timelimit*60*TICRATE - 60*TICRATE) and (p.kartstuff[k_growshrinktimer] == 0 and p.kartstuff[k_invincibilitytimer] == 0) and S_GetMusicPosition() <= 1000 / TICRATE then
						COM_BufInsertText(p, "tunes DELFOF")
						S_SetMusicPosition( (((leveltime - (starttime + (TICRATE/2) + 1)) * 1000) / TICRATE) )
					end
					if p.realtime >= (server.deli_timelimit*60*TICRATE - 60*TICRATE) and (p.kartstuff[k_growshrinktimer] == 0 and p.kartstuff[k_invincibilitytimer] == 0) and S_GetMusicPosition() <= 1000 / TICRATE then
						COM_BufInsertText(p, "tunes DELEFO")
						S_ShowMusicCredit()
						S_SetMusicPosition( (((leveltime - starttime - (server.deli_timelimit*60*TICRATE - 60*TICRATE)) * 1000) / TICRATE) )
					end
				else
					if p.realtime >= (server.deli_timelimit*60*TICRATE - 60*TICRATE) and (p.kartstuff[k_growshrinktimer] == 0 and p.kartstuff[k_invincibilitytimer] == 0) and S_GetMusicPosition() <= 1000 / TICRATE then
						COM_BufInsertText(p, "tunes DELNON")
						S_ShowMusicCredit()
						S_SetMusicPosition( (((leveltime - starttime - (server.deli_timelimit*60*TICRATE - 60*TICRATE)) * 1000) / TICRATE) )
					end
				end
			end
			if leveltime == (starttime + (TICRATE/2) + 1)
				if server.deli_timelimit == 3 then 
					--print(server.deli_timelimit)
					COM_BufInsertText(p, "tunes DELFOF")
					S_ShowMusicCredit()
					--print(S_MusicName())
				end
			end
			if server.deli_timelimit > 1 then -- make sure timer's actually fuckin counting down, we also have a special case for 1 minute
				if p.realtime == (server.deli_timelimit*60*TICRATE - 60*TICRATE) and (p.kartstuff[k_growshrinktimer] == 0 and p.kartstuff[k_invincibilitytimer] == 0) then
					if server.deli_timelimit == 3 and S_MusicName() == "DELFOF" then
						COM_BufInsertText(p, "tunes DELEFO")
						S_ShowMusicCredit()
					else
						COM_BufInsertText(p, "tunes DELNON")
						S_ShowMusicCredit()
					end 
				end
				if battleplus and p.realtime >= (server.deli_timelimit*60*TICRATE + 1*TICRATE) and server.bp_roundstalemate and server.spbmusic == nil then	--don't do shit if dynmusic has spb themes loaded
					COM_BufInsertText(p, "tunes ENON14")
					--S_ShowMusicCredit()
				end
			elseif server.deli_timelimit == 1 then 
				if leveltime == (starttime + (TICRATE/2) + 1)
					COM_BufInsertText(p, "tunes ENON14")
					S_ShowMusicCredit()
				end
			end
		end
	end
end)

--DeliPipe made by minenice#7916