--code for Deli24's Senpai Cannon

--notes: 

--chopper starts at the left side (alpha's left), ends at the right (bravo's left, next to the NILS), circles 1 and a half times around the stage
--chopper finishes rotation at 120 seconds, where it moves to the centre (alpha's left, bravo's right)

--now on xItem

--item flags
local XIF_POWERITEM = 1 --is power item (affects final odds)
local XIF_COOLDOWNONSTART = 2 --can't be obtained on start cooldown
local XIF_UNIQUE = 4 --only one can exist in anyone's slot
local XIF_LOCKONUSE = 8 --locks the item slot when the item is used, slot must be unlocked manually by setting player.xItemData.xItem_itemSlotLocked to false
local XIF_COOLDOWNINDIRECT = 16 --checks if indirectitemcooldown is 0
local XIF_COLPATCH2PLAYER = 32 --map hud patch colour to player prefcolor
local XIF_ICONFORAMT = 64 --item icon changes depending on the item amount (animation frames become amount frames)

--apparently this makes shit faster? wtf?
local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
local MAXSKINCOLORS = MAXSKINCOLORS
local ANG1 = ANG1
local k_sneakertimer = k_sneakertimer
local k_spinouttimer = k_spinouttimer
local k_wipeoutslow = k_wipeoutslow
local k_driftboost = k_driftboost
local k_floorboost = k_floorboost
local k_startboost = k_startboost
local k_itemamount = k_itemamount
local k_itemtype = k_itemtype
local k_rocketsneakertimer = k_rocketsneakertimer
local k_hyudorotimer = k_hyudorotimer
local k_drift = k_drift
local k_speedboost = k_speedboost
local k_accelboost = k_accelboost
local k_invincibilitytimer = k_invincibilitytimer
local k_growshrinktimer = k_growshrinktimer
local k_throwdir = k_throwdir

local splitplayers = {}
local function splitnum(p)

	for i = 1, #splitplayers do
		if splitplayers[i] == p
			return i-1
		end
	end
end

local function AT_lerp(num, denum, minimum, maximum)
	local p = FixedDiv(num*FRACUNIT, denum*FRACUNIT)
	local a = FixedMul((maximum * FRACUNIT - minimum * FRACUNIT), p)
	local v = minimum * FRACUNIT + a
	return v / FRACUNIT
end

local function AT_flerp(num, denum, minimum, maximum)
	local p = FixedDiv(num, denum)
	local a = FixedMul((maximum - minimum), p)
	local v = minimum + a
	return v
end

local function AT_sign(num)
	if num == 0 then return 0 end
	if num < 0 then return -1 end
	if num > 0 then return 1 end
end

--constants for "balance"
local keepdist = 50*FRACUNIT	--distance that the lazer orbits around the player when aiming

local spawndist = -50*FRACUNIT		--distance from the player when spawning (directly above the player)
local spawnheight = 0

local shotmaxsizetic = 132
local shotspreadtic = TICRATE / 2
local shotinitscale = 0
local shottargetscale = 7*FRACUNIT/4
local shotwaittic = TICRATE + (TICRATE / 2)
local shotoffset = 200*FRACUNIT
local shotoffsetz = 64*FRACUNIT
local shotdist = 15000*FRACUNIT
local shotrad = 150*FRACUNIT

local autofiretic = 8*TICRATE + TICRATE/2


local function checksuperlazercol(mo)
	local height -- vertical range
	local dist -- horizontal range
	local l -- true range
	
	height = mo.target.z - mo.z
	dist = R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y)
	
	if (dist > FixedMul(shotrad, mo.scale)) then return false end
	
	l = P_AproxDistance(dist, height)

	if (l <= FixedMul(shotrad, mo.scale) and AT_sign(l) ~= -1) then
		return true
		
	else
		return false
		
	end
end

local function createsuperlazer(p, i)
	--print("create lazer")
	local kartstuff = p.kartstuff
	
	kartstuff[k_spinouttimer] = 0
	kartstuff[k_wipeoutslow] = 0
	
	K_DropItems(p)
	K_StripOther(p)
	
	--give the player the superlazer
	kartstuff[k_itemtype] = xItemLib.xItemNamespaces["XITEM_SENPAICANNON"]
	kartstuff[k_itemamount] = 1
	
	kartstuff[k_itemblink] = TICRATE
	kartstuff[k_itemblinkmode] = 2
	
	p.hassuperlazer = true		
	p.superlazertime = autofiretic		--timer before auto-fire
	
	local sx = FixedMul(FixedMul(spawndist, cos(p.mo.angle)), mapobjectscale)
	local sy = FixedMul(FixedMul(spawndist, sin(p.mo.angle)), mapobjectscale)
	
	S_StartSound(p.mo, sfx_scprep)
	local senpai = P_SpawnMobj(sx + p.mo.x, sy + p.mo.y, p.mo.z + FixedMul(spawnheight, mapobjectscale), MT_SUPERLAZER)		--spawn in the superlazer
	senpai.angle = p.mo.angle
	senpai.vangle = -6*ANG1
	
	senpai.color = p.skincolor
	
	senpai.user = p
	p.senpai = senpai
	
	senpai.spawntic = leveltime
	senpai.used = false
	
	senpai.sx = senpai.x + FixedMul(FixedMul(shotoffset, cos(senpai.angle)), mapobjectscale)
	senpai.sy = senpai.y + FixedMul(FixedMul(shotoffset, sin(senpai.angle)), mapobjectscale)
	senpai.sz = senpai.z + shotoffsetz
	
	senpai.dx = FixedMul(FixedMul(shotdist, cos(senpai.angle)), mapobjectscale)
	senpai.dy = FixedMul(FixedMul(shotdist, sin(senpai.angle)), mapobjectscale)
	senpai.dz = FixedMul(FixedMul(shotdist, sin(senpai.vangle)), mapobjectscale)
	
	S_StartSound(p.mo, sfx_scprep)
	K_PlayPowerGloatSound(p.mo)
	
	if splitscreen < 2 then -- don't change shit for THIS splitscreen.
		S_StartSound(p.mo, sfx_scplul, p)
	else -- now we're having a fun game.
		if displayplayers[0] == p or displayplayers[2] == p then -- If we are P1 or P3...
			S_StartSound(p.mo, sfx_scplul, p)
		else -- else, that means we're P2 or P4.
			S_StartSound(p.mo, sfx_scplur, p)
		end
	end
end

rawset(_G, "deli_createsuperlazer", function(p, i)
	createsuperlazer(p, i)
end)

--modified archvile code for lazerbeam
local function spawnsenpailazer(parent, actor, range, spacing, scale, sound)
	local dx = parent.dx
	local dy = parent.dy
	
	local sx = parent.sx
	local sy = parent.sy
	local sz = parent.sz
	
	local numLineMobjs = R_PointToDist2(sx, sy, dx, dy)/(spacing)
			
	local i = 0
	while (i <= numLineMobjs)
		local part
		part = P_SpawnMobj(sx + FixedMul(FixedMul(spacing * i, cos(parent.angle)), mapobjectscale), sy + FixedMul(FixedMul(spacing * i, sin(parent.angle)), mapobjectscale), sz + FixedMul(FixedMul(spacing * i, sin(parent.vangle)), mapobjectscale), actor)
			part.scale = FixedMul(scale, mapobjectscale)
			part.id = i
			part.senpai = parent
			part.spawntime = leveltime
			part.color = parent.color
			part.angle = parent.angle + 90*ANG1
			if sound then
				S_StartSound(part, sound)
			end
		i = $+1
	end
end

addHook("MapLoad", function()	--player reset
	for p in players.iterate
		p.hassuperlazer = false
		p.superlazertime = false
		p.senpai = nil
		p.slinvuln = 0
	end
end)

local function useSuperLazer(p, cmd)
	p.senpai.used = true
	p.hassuperlazer = false
	P_InstaThrust(p.mo, p.mo.angle - 180*ANG1, 8*FRACUNIT)
	p.kartstuff[k_itemamount] = 0
end

addHook("ThinkFrame", do
	for p in players.iterate do
		if not p.hassuperlazer then p.hassuperlazer = false end
		if not p.superlazertime then p.superlazertime = 0 end
		if not p.superlazerturnframes then p.superlazerturnframes = 0 end
		if not p.superlazervturnframes then p.superlazervturnframes = 0 end
		if not p.slinvuln then p.slinvuln = 0 end
		
		if p.superlazertime then p.superlazertime = $-1 end
		if p.slinvuln then p.slinvuln = $-1 end
		
		if p.mo and not p.exiting then
			
			--if (p.cmd.buttons & BT_CUSTOM1) then		--debug
				--K_SpinPlayer(p, p.mo, 1, p.mo, false)
			--end
			
			if p.hassuperlazer then
				p.cmd.buttons = $ &~ BT_ACCELERATE|BT_BRAKE|BT_DRIFT
				if p.senpai and (not p.senpai.used) and leveltime % 35 == 0 then	--reticle stuff
					local sx = p.senpai.x + FixedMul(FixedMul(shotoffset, cos(p.senpai.angle)), mapobjectscale)
					local sy = p.senpai.y + FixedMul(FixedMul(shotoffset, sin(p.senpai.angle)), mapobjectscale)
					local sz = p.senpai.z + shotoffsetz
					
					local reticle = P_SpawnMobj(sx, sy, sz, MT_SUPERLAZERBEAMRETICLE)
					reticle.senpai = p.senpai
					reticle.spawntime = leveltime
					reticle.color = SKINCOLOR_WHITE
					reticle.scale = 2*FRACUNIT/3
					
					if (splitscreen) then
						if reticle.senpai.user == displayplayers[0] then
							reticle.eflags = $|MFE_DRAWONLYFORP1
						elseif  reticle.senpai.user == displayplayers[1] then
							reticle.eflags = $|MFE_DRAWONLYFORP2
						elseif  reticle.senpai.user == displayplayers[2] and splitscreen > 1 then
							reticle.eflags = $|MFE_DRAWONLYFORP3
						elseif  reticle.senpai.user == displayplayers[3] and splitscreen > 2 then
							reticle.eflags = $|MFE_DRAWONLYFORP4
						else
							reticle.flags2 = $|MF2_DONTDRAW
						end
					else
						if reticle.senpai.user == displayplayers[0] then
							reticle.flags2 = $ &~ MF2_DONTDRAW
						else
							reticle.flags2 = $|MF2_DONTDRAW
						end
					end
				end
				
				if p.cmd.driftturn then		--horizontal aiming
					p.superlazerturnframes = $+1
					if p.superlazerturnframes > 35 then
						p.mo.angle = $+(5*ANG1*AT_sign(p.cmd.driftturn))
					else
						if p.superlazerturnframes > 17 then
							p.mo.angle = $+(ANG2*AT_sign(p.cmd.driftturn))
						else
							p.mo.angle = $+(ANG1*AT_sign(p.cmd.driftturn))
						end
					end
				else
					if p.superlazerturnframes then
						p.superlazerturnframes = 0
					end
				end
				
				if p.kartstuff[k_throwdir] then		--vertical aiming
					p.superlazervturnframes = $+1
					if p.superlazervturnframes > 17 then
						p.senpai.vangle = $+(ANG2*AT_sign(p.kartstuff[k_throwdir]))
					else
						p.senpai.vangle = $+(ANG1*AT_sign(p.kartstuff[k_throwdir]))
					end
					p.senpai.vangle = min(max(p.senpai.vangle, -10*ANG1), 10*ANG1)	--clamp v-aim
					
				else
					if p.superlazervturnframes then
						p.superlazervturnframes = 0
					end
				end
				
				if p.superlazertime <= 0 then
					useSuperLazer(p, p.cmd)
				end
			end
		end
	end
end)

addHook("MobjThinker", function(senpai)
	if senpai.user then
		local ang = senpai.user.mo.angle
		local posx = senpai.user.mo.x
		local posy = senpai.user.mo.y
		local posz = senpai.user.mo.z
		
		senpai.sx = senpai.x + FixedMul(FixedMul(shotoffset, cos(senpai.angle)), mapobjectscale)
		senpai.sy = senpai.y + FixedMul(FixedMul(shotoffset, sin(senpai.angle)), mapobjectscale)
		senpai.sz = senpai.z + shotoffsetz
		
		senpai.dx = FixedMul(FixedMul(shotdist, cos(senpai.angle)), mapobjectscale)
		senpai.dy = FixedMul(FixedMul(shotdist, sin(senpai.angle)), mapobjectscale)
		senpai.dz = FixedMul(FixedMul(shotdist, sin(senpai.vangle)), mapobjectscale)
		
		if (leveltime - senpai.spawntic) == 0 then
			K_StripOther(senpai.user)
			senpai.angle = InvAngle(ang)
			local sx = FixedMul(FixedMul(spawndist, cos(ang)), mapobjectscale)
			local sy = FixedMul(FixedMul(spawndist, sin(ang)), mapobjectscale)
			P_TeleportMove(senpai, posx + sx, posy + sy, posz)
		end
		if (leveltime - senpai.spawntic) == 1 then
			K_StripOther(senpai.user)
			senpai.angle = ang
			local sx = FixedMul(FixedMul(0, cos(ang)), mapobjectscale)
			local sy = FixedMul(FixedMul(0, sin(ang)), mapobjectscale)
			P_TeleportMove(senpai, posx + sx, posy + sy, posz + FixedMul(40*FRACUNIT, mapobjectscale))
		end
		if (leveltime - senpai.spawntic) >= 2 then
			if not senpai.used then
				K_StripOther(senpai.user)		--also remove invinc, grow and eggman
				senpai.user.kartstuff[k_driftboost] = 0		--other status effects too
				senpai.user.kartstuff[k_boostpower] = 0
				senpai.user.mo.momx = 0
				senpai.user.mo.momy = 0
				if senpai.user.mo.momz > 0 then senpai.user.mo.momz = 0 end
				
				senpai.angle = ang
				local sx = FixedMul(FixedMul(keepdist, cos(ang)), mapobjectscale)
				local sy = FixedMul(FixedMul(keepdist, sin(ang)), mapobjectscale)
				P_TeleportMove(senpai, posx + sx, posy + sy, posz)
			else
				if senpai.state == S_SUPERLAZERIDLE then
				senpai.angle = ang
				local sx = FixedMul(FixedMul(keepdist, cos(ang)), mapobjectscale)
				local sy = FixedMul(FixedMul(keepdist, sin(ang)), mapobjectscale)
				senpai.usedtic = leveltime
				
				senpai.state = S_SUPERLAZERFIRE1
				
				spawnsenpailazer(senpai, MT_SUPERLAZERBEAMWARN, shotdist, 180*FRACUNIT, 6*FRACUNIT/4, false)
				spawnsenpailazer(senpai, MT_SUPERLAZERSFX, shotdist, 900*FRACUNIT, FRACUNIT, sfx_scpron)
				end
				if senpai.usedtic then
					if leveltime == senpai.usedtic + shotwaittic then
						senpai.sfx = P_SpawnMobj(senpai.x, senpai.y, senpai.z, MT_SUPERLAZERSFX)
						
						senpai.shottic = leveltime
						spawnsenpailazer(senpai, MT_SUPERLAZERBEAMCORE, shotdist, 100*FRACUNIT, shotinitscale, false)
						spawnsenpailazer(senpai, MT_SUPERLAZERBEAM, shotdist, 240*FRACUNIT, shotinitscale, false)
						spawnsenpailazer(senpai, MT_SUPERLAZERSFX, shotdist, 900*FRACUNIT, FRACUNIT, sfx_scmaaa)
					end
				end
				if senpai.shottic then
				
					
					
					if leveltime == senpai.shottic + shotmaxsizetic + shotspreadtic then
						local i = 0
						while i <= 8 do
							local spark = P_SpawnMobj(senpai.x+P_RandomRange(-40, 40)*senpai.scale, senpai.y+P_RandomRange(-40, 40)*senpai.scale, senpai.z+P_RandomRange(5, 20)*senpai.scale, MT_SMOKE)
							P_SetObjectMomZ(spark, P_RandomRange(8, 10)*senpai.scale)
							i = $+1
						end
						i = 0
						while i <= 15 do
							local spark = P_SpawnMobj(senpai.x+P_RandomRange(-100, 100)*senpai.scale, senpai.y+P_RandomRange(-100, 100)*senpai.scale, senpai.z+P_RandomRange(0, 60)*senpai.scale, MT_SPARKLETRAIL)
							spark.color = senpai.color
							P_SetObjectMomZ(spark, P_RandomRange(10, 20)*senpai.scale)
							i = $+1
						end
					
						P_RemoveMobj(senpai)
					end
				end
				end
	end
	else
		senpai.destscale = 0
		senpai.scalespeed = FRACUNIT/35
		if senpai.scale == 0 then
			local smoke = P_SpawnMobj(senpai.x, senpai.y, senpai.z, MT_SMOKE)
			P_SetObjectMomZ(smoke, P_RandomRange(8, 10)*senpai.scale)
			senpai.state = S_NULL
		end
	end
end, MT_SUPERLAZER)

addHook("MobjThinker", function(part)
	if leveltime < part.spawntime + shotspreadtic then
		part.scale = AT_flerp((leveltime - part.spawntime)*FRACUNIT, shotspreadtic * FRACUNIT, shotinitscale, shottargetscale)
	end
	if leveltime == part.spawntime + shotspreadtic then
		part.scale = shottargetscale
	end
	
	if leveltime < part.spawntime + shotmaxsizetic + shotspreadtic then
		for p in players.iterate do
			if p.mo and p.mo.valid then
				part.target = p.mo
				--todo: check bp teammates
				if p == part.senpai.user then continue end
				if checksuperlazercol(part) and p.kartstuff[k_invincibilitytimer] == 0 and p.powers[pw_flashing] == 0 and p.kartstuff[k_growshrinktimer] <= 0 and p.kartstuff[k_hyudorotimer] == 0 then
					if ((battleplus) and ((server.bp_teamgamemode == 0) and ((p.bp_teamcolor == part.senpai.user.bp_teamcolor) and (cv_bp_ff.value)))) then
						K_DoInstashield(p)
						continue
					end
					if p.slinvuln == 0 then
						P_DamageMobj(p.mo, part.senpai, part.senpai.user.mo, 10000)
						deli_inkballexp(part.target.x, part.target.y, part.target.z, part.senpai.color)
						p.slinvuln = TICRATE*8
						local s = {{part.senpai.user.name, part.senpai.user.hf_overridenamecolor or part.senpai.color}, {skins[part.senpai.user.mo.skin].facemmap, part.senpai.color}, part.senpai.user}
						local v = {{p.name, p.hf_overridenamecolor or p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
						if (hitfeed) then HF_SendHitMessage(s, v, "K_LZRICN", part.senpai.color) end		--hitfeed compatibility
					end
				end
			end
		end
		for i, b in ipairs(server.deli_lidabombs) do
			if b then
				if not b.valid then continue end
				if b.expltime then continue end
				part.target = b
				if checksuperlazercol(part) then
					b.expltime = leveltime
					b.color = part.senpai.color
					b.state = S_BOMBLIDAEXPLODE
					b.user = part.senpai.user
				end
			end
		end
	end
	if leveltime > ((part.spawntime + shotmaxsizetic + shotspreadtic) - TICRATE/4) then
		part.destscale = 0
		part.scalespeed = shottargetscale/(TICRATE/4)
	end
	if leveltime == part.spawntime + shotmaxsizetic + shotspreadtic then
		local i = 0
		while i <= 4 do
			local spark = P_SpawnMobj(part.x+P_RandomRange(-200, 200)*mapobjectscale, part.y+P_RandomRange(-200, 200)*mapobjectscale, part.z+P_RandomRange(-64, 64)*mapobjectscale, MT_SPARKLETRAIL)
			spark.color = part.color
			P_SetObjectMomZ(spark, P_RandomRange(4, 10)*mapobjectscale)
			i = $+1
		end
		part.state = S_NULL
	end
end, MT_SUPERLAZERBEAMCORE)

addHook("MobjThinker", function(part)
	if leveltime < part.spawntime + shotspreadtic then
		part.scale = AT_flerp((leveltime - part.spawntime), shotspreadtic, shotinitscale, shottargetscale)
	end
	if leveltime == part.spawntime + shotspreadtic then
		part.scale = shottargetscale
	end
	if leveltime > ((part.spawntime + shotmaxsizetic + shotspreadtic) - TICRATE/4) then
		part.destscale = 0
		part.scalespeed = shottargetscale/(TICRATE/4)
	end
	if leveltime == part.spawntime + shotmaxsizetic + shotspreadtic then
		part.state = S_NULL
	end
end, MT_SUPERLAZERBEAM)

addHook("MobjThinker", function(part)
	if part.id == (leveltime - part.spawntime) then
		part.flags2 = MF2_DONTDRAW
	else
		part.flags2 = 0
	end
	if leveltime == part.senpai.usedtic + shotwaittic + shotspreadtic then
		part.state = S_NULL
	end
end, MT_SUPERLAZERBEAMWARN)

addHook("MobjThinker", function(part)
	local dx = FixedMul(FixedMul((leveltime - part.spawntime)*FRACUNIT*16, cos(part.senpai.angle)), mapobjectscale)
	local dy = FixedMul(FixedMul((leveltime - part.spawntime)*FRACUNIT*16, sin(part.senpai.angle)), mapobjectscale)
	local dz = FixedMul(FixedMul((leveltime - part.spawntime)*FRACUNIT*16, sin(part.senpai.vangle)), mapobjectscale)
	P_TeleportMove(part, part.senpai.x + dx, part.senpai.y + dy, part.senpai.z + dz + shotoffsetz)
	part.angle = part.senpai.angle + 90*ANG1
	if leveltime - part.spawntime == 10*TICRATE or part.senpai == nil or part.senpai.used == true then
		part.state = S_NULL
	end
end, MT_SUPERLAZERBEAMRETICLE)

-- spin
addHook("PlayerSpin", function(p, inflictor, source)
	if p.hassuperlazer then
		p.senpai.user = nil
		p.senpai = nil
		p.hassuperlazer = false
		p.superlazertime = 0
	end
end)
-- squish
addHook("PlayerSquish", function(p, inflictor, source)
	if p.hassuperlazer then
		p.senpai.user = nil
		p.senpai = nil
		p.hassuperlazer = false
		p.superlazertime = 0
	end
end)
-- explode
addHook("PlayerExplode", function(p, inflictor, source)
	if p.hassuperlazer then
		p.senpai.user = nil
		p.senpai = nil
		p.hassuperlazer = false
		p.superlazertime = 0
	end
end)
-- quitting like a noob lol
addHook("PlayerQuit", function(p, r)
	if p.hassuperlazer then
		p.senpai.user = nil
		p.senpai = nil
		p.hassuperlazer = false
		p.superlazertime = 0
	end
end)

local function senpaiCannonHud(v, p, c)
	local mo = p.mo
	if p.hassuperlazer then
		xItemLib.func.hudDrawItem(v, p, c, xItemLib.xItemNamespaces["XITEM_SENPAICANNON"], 2)
		p.xItemData.xItem_timerBar = p.superlazertime or 0
		p.xItemData.xItem_maxTimerBar = autofiretic
	else
		xItemLib.func.hudDrawItem(v, p, c, xItemLib.xItemNamespaces["XITEM_SENPAICANNON"])
	end
end

local function senpaiCannonDropped(mo, i, amt)
	mo.state = S_NULL
	return SPR_ITEM, 0
end

if xItemLib then
	xItemLib.func.addItem{"XITEM_SENPAICANNON", "Princess Cannon", "ITEMLAZR", "ITESLAZR", XIF_COLPATCH2PLAYER, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, {0, 0}, createsuperlazer, useSuperLazer, senpaiCannonHud, false, false, {0, {SPR_DESL, F}}, false, nil, senpaiCannonDropped}
end